<template>
  <div v-if="user" class="kyc-content">
    <div class="title-page">
      {{ $t('kyc.title') }}
    </div>
    <template v-if="!user.is_deposited">
      <div class="kyc-message" v-if="isRenderWarningDeposit">
        <p>{{ $t('kyc.message') }}</p>
        <button type="button" @click="$router.push('/deposit')">{{ $t('kyc.btn_deposit') }}</button>
      </div>
    </template>
    <div id="idensic" v-else></div>
  </div>
</template>
<script>
import { mapState, mapMutations } from 'vuex';
import rf from '../../common/requests/RequestFactory';

export default {
  data() {
    return  {
      isRenderWarningDeposit: false
    }
  },
  methods: {
    ...mapMutations([
      'updateUser'
    ]),
    async initIdCheck () {
      const token = await rf.getRequest('UserKycRequest').getSumSubToken();
      const result = await rf.getRequest('UserKycRequest').getApplicant();
      const applicant = result.data;

      let config = {
        accessToken: token.data,
        applicantDataPage: {
          enabled: true,
          fields: [
            {
              name: 'firstName',
              required: true
            },
            {
              name: 'lastName',
              required: true
            }
          ]
        },
        requiredDocuments: 'IDENTITY:ID_CARD,PASSPORT,DRIVERS;SELFIE:SELFIE;PROOF_OF_RESIDENCE:UTILITY_BILL'
      };

      if (applicant) {
        config = {
          accessToken: token.data,
          applicantId: applicant.applicant_id
        };
      }
      const self = this;
      window.idensic.init(
        '#idensic',
        config,
        function (messageType, payload) {
          if (messageType === 'idCheck.onApplicantCreated' && !applicant) {
            const params = {
              user_id: self.user.id,
              applicant_id: payload.applicantId,
            };

            rf.getRequest('UserKycRequest').create(params);
          } else if (messageType === 'idCheck.onApplicantSubmitted' || messageType === 'idCheck.onApplicantResubmitted') {
            rf.getRequest('UserRequest').updateUserInfoAfterKyc()
              .then(res => {
                self.updateUser(res.data);
              });
          }
        }
      );
    },
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  watch: {
    user: {
      handler: function(val, oldVal) {
        if (!!val && _.isEmpty(oldVal)) {
          if (val.is_deposited) {
            this.initIdCheck();
          }
          setTimeout(() => {
            this.isRenderWarningDeposit = true;
          }, 800);
        }
      },
      immediate: true
    }
  },
};
</script>

<style lang="scss" scoped>
  @import '../../../sass/mobile/typoVariables.scss';

  .kyc-content {
    height: auto;
    background: $bg_primary;
    .title-page {
      padding: 13rem 12rem 13rem;
      background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
      box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
      font-size: 18rem;
      color: $white;
    }

    .title-page {
      padding-left: 12rem;
      padding-right: 12rem;
    }
    .kyc-message {
      text-align: center;
      padding: 37rem 33rem 37rem;
      p {
        font-size: 14rem;
        font-weight: normal;
        font-style: normal;
        font-stretch: normal;
        line-height: 1.57;
        letter-spacing: normal;
        text-align: center;
        color: #989898;
      }
      button {
        width: 100rem;
        height: 32rem;
        border-radius: 30rem;
        margin-top: 26rem;
        background-color: #fa7300;
        border: 1rem solid #fa7300;
        font-size: 12rem;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        outline: none;
        letter-spacing: 0.5rem;
        color: #ffffff;
      }
    }
  }
</style>
